<script setup>
    import {computed, ref} from "vue";
    import PersonTable from "@/components/PersonTable.vue";

    const persons = ref([
        {
            firstName: 'Max',
            lastName: 'Muster',
            birthYear: 1750
        },
        {
            firstName: 'Najo',
            lastName: 'Muster',
            birthYear: 2000
        },
        {
            firstName: 'Test',
            lastName: 'Muster',
            birthYear: 2010
        },
        {
            firstName: 'Foo',
            lastName: 'Muster',
            birthYear: 2015
        }
    ])

    //const adults = computed(() => persons.value.filter(person => person.birthYear <= 2005))
    const adults = computed(() => persons.value.filter(person => person.birthYear <= 2005))
    const children = computed(() => persons.value.filter(person => person.birthYear > 2005))

    function deletePersonFromArray(person) {
        const personIndex = persons.value.findIndex(p => p.firstName === person.firstName && p.lastName === person.lastName)
        if(personIndex >= 0) {
            persons.value.splice(personIndex, 1)
        }
    }
</script>

<template>
    <h1>Hallo Welt</h1>

    <h2>Erwachsene</h2>
    <person-table :person-array="adults" @delete="deletePersonFromArray"/>
    <!--<PersonTable :personArray="persons" @delete="deletePersonFromArray"/>
    <PersonTable :person-array="persons" @delete="deletePersonFromArray"/>
    <person-table :personArray="persons" @delete="deletePersonFromArray"/>-->

    <h2>Kinder</h2>
    <person-table :person-array="children" @delete="deletePersonFromArray"/>
</template>
